import woob.capabilities.base as OLD

# can't import *, __all__ is incomplete...
for attr in dir(OLD):
    globals()[attr] = getattr(OLD, attr)

try:
    __all__ = OLD.__all__
except AttributeError:
    pass


def find_object_any_match(objects, key_value_pairs, error=None, with_priority=True, ignore_empty=True):
    # Will be used if with_priority is true
    found = None
    found_index = None

    for o in objects:
        for index, (key, value) in enumerate(key_value_pairs):
            # There is no point trying to match as it will be not priorized
            if found_index and found_index <= index:
                break

            o_value = getattr(o, key)
            if (
                ignore_empty and (empty(value) or empty(o_value))
                or o_value != value
            ):
                continue

            # First key is a special case with priority, we can return early
            # if we find a match on the first key
            # Also we only keep more priorized matches
            if not with_priority or index == 0:
                return o

            found = o
            found_index = index

    if not found and error is not None:
        raise error()
    return found


del OLD
